using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;
using System.Text.RegularExpressions;
using System.Windows;

/*
 * 001@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
 * THIS SAMPLE PROGRAM WAS WRITTEN TO SHOW THE AgileTelecomSMS CLASS IMPLEMENTATION
 * 
 * FIRST YOU HAVE TO IMPORT THE AgileTelecomSMS.dll IN THE REFERENCES OF YOUR .NET POJECT
 * (CLICK ON "PROJECT", THEN "ADD REFERENCE", "BROWSE" AND THEN SELECT THE AgileTelecomSMS.dll)
 * 
 * IMPORTS AgileTelecomSMS CLASS IN YOUR FORM CLASS
*/
using com.agiletelecom.NET;
//@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
namespace AgileTelecomSMS_Csharp
{
    public partial class Form1 : Form
    {
        /*002@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
         * 
         *
         *DECLARE AND INITIALIZE AN INSTANCE OF AgileTelecomSMS CLASS
         *SO mySMS OBJECT IS AN INSTANCE OF AgileTelecomSMS CLASS
        */
        AgileTelecomSMS mySMS = new AgileTelecomSMS();
        //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        public Form1()
        {
            InitializeComponent();
            /*
             * 003@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *POPULATE THE SMS TYPE COMBOBOX IN THE FORM WHEN FORM IS LOADED
            */
            PopulateSMSType();
        }
        private void txtNewGSM_TextChanged(object sender, EventArgs e)
        {
            /*
             * 004@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             * THIS IS A CHECK OF GSM SYNTAX FOR NEW GSM FIELDS
             * REGEX IS A MEMBER OF THE System.Text.RegularExpressions CLASS
            */
            if (!Regex.IsMatch(txtNewGSM.Text, "^\\+{1}\\d{10,15}$") & txtNewGSM.Text.Length > 10)
                MessageBox.Show("Wrong GSM number.", "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        private void txtNewGSM_GotFocus(object sender, EventArgs e)
        {
            /*
             * 005@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             * INSERT PLUS (+) SIGN IN THE NEW GSM FIELD WHEN IT GET FOCUS AND IS EMPTY
            */
            if (txtNewGSM.Text.Trim() == "")
            {
                txtNewGSM.Text = "+";
                txtNewGSM.SelectionStart = txtNewGSM.Text.Length;
                txtNewGSM.SelectionLength = 1;
                txtNewGSM.Select();
            }
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        }
        private void cmdAddGSM_Click(object sender, EventArgs e)
        {
            /*
             * 006@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             * CHECK THE GSM SYNTAX 
            */
            if (Regex.IsMatch(txtNewGSM.Text, "^\\+{1}\\d{10,15}$"))
            {
                /*USE THE add_GSM METHOD TO ADD A NEW GSM TO YOUR mySMS CLASS OBJECT
                 * 
                 * *NOTE THAT THE add_GSM METHOD QUIETLY DOES NOT ADD TWO TIMES THE SAME GSM NUMBER, JUST SILENTLY WILL SKIPPED*
                */
                mySMS.add_GSM(txtNewGSM.Text);
                Populate_list();
            }
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        private void btnDelGSMNumber_Click(object sender, EventArgs e)
        {

            /*007@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *TRY TO DELETE A GSM NUMBER IN THE mySMS CLASS OBJECT USING THE remove_GSM METHOD 
             *IN THIS CASE remove_GSM METHOD WILL TRY TO FIND AND DELETE THE GSM NUMBER PASSED BY THE TEXT BOX
             **NOTE THAT remove_GSM METHOD CAN ALSO ACCEPT PARAMETER INTEGER AS A INDEX OF mySMS.get_GSM ArrayList*
             *EXCEPTIONS IN THIS PROGRAM WILL BE SHOW AS A MESSAGE BOX
             *THEN CALL THE Populate_list() Sub TO REFRESH THE LISTBOX ON THE FORM
            */
            if (Regex.IsMatch(txtNewGSM.Text, "^\\+{1}\\d{10,15}$"))
            {
                try
                {
                    mySMS.remove_GSM(txtNewGSM.Text);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
                    txtNewGSM.SelectionStart = txtNewGSM.Text.Length;
                    txtNewGSM.SelectionLength = 1;
                    txtNewGSM.Select();
                    txtNewGSM.Focus();
                }
                Populate_list();
            }
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

        }
        private void lstGSM_SelectedIndexChanged(object sender, EventArgs e)
        {
            /*
             * 008@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *ENABLE OR DISABLE BUTTON
            */
            if (lstGSM.SelectedIndex > -1)
                btnGSMDeleteSelected.Enabled = true;
            else
                btnGSMDeleteSelected.Enabled = false;
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        private void btnGSMDeleteSelected_Click(object sender, EventArgs e)
        {
            /*009@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *TRY TO DELETE A GSM NUMBER IN THE mySMS CLASS OBJECT USING THE remove_GSM METHOD 
             *remove_GSM METHOD IN THIS CASE WILL TRY TO DELETE THE GSM IN THE mySMS.get_GSM ArrayList AT THE PASSED INDEX
             **NOTE THAT remove_GSM METHOD CAN ALSO ACCEPT PARAMETER STRING AS A GSM NUMBER*
            */
            if (lstGSM.SelectedIndex > -1)
            {
                mySMS.remove_GSM(lstGSM.SelectedIndex);
                Populate_list();
            }
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        /*
         * 010@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
         *CALL THIS PRIVATE SUB TO CLEAR ALL GSM IN YOUR LIST
        */
        private void Clear_List()
        {
            lstGSM.Items.Clear();
            btmClearGsm.Enabled = false;
            btnGSMDeleteSelected.Enabled = false;
        }
        /*
         * 011@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
         *CALL THIS PRIVATE SUB TO REFRESH THE GSM LIST ON YOUR FORM
        */
        private void Populate_list()
        {
            /*
             * 012@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *DECLARE AN ArrayList OBJECT
            */
            ArrayList my_GSM_Array = new ArrayList();
            /*
             * 013@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *CLEAR THE GSM LIST ON FORM
            */
            lstGSM.Items.Clear();
            btmClearGsm.Enabled = false;
            btnGSMDeleteSelected.Enabled = false;
            /*
             * 014@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *USE THE get_GSM METHOD TO FILL DATA IN THE ArrayList OBJECT CREATED BEFORE
            */
            my_GSM_Array = mySMS.get_GSM;
            /*
             * 015@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *CYCLE THE ArrayList OBJECT AND ADD EACH ITEMS IN YOUR LISTBOX ON FORM
            */
            for (int i = 0; i < my_GSM_Array.Count; i++)
            {
                lstGSM.Items.Add(my_GSM_Array[i]);
                btmClearGsm.Enabled = true;
            }
        }
        private void btmClearGsm_Click(object sender, EventArgs e)
        {
            /*
             * 016@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *THIS CALL THE METHOD mySMS.clear_GSM() TO CLEAR ALL GSM LIST IN THE mySMS CLASS OBJECT
             *THEN CLEAR THE FORM LISTBOX
            */
            mySMS.clear_GSM();
            Clear_List();
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        private void txtSender_LostFocus(object sender, EventArgs e)
        {
            /*+017@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *ON LOST FOCUS FOR THE SENDER FIELD, THE SENDER FIELD VALUE IS PASSED AT mySMS OBJECT CLASS USING THE mySMS.Sender PROPERTY
             *IF THE mySMS OBJECT CLASS CHANGE THE SENDER SYNTAX A CUSTOM MESSAGE BOX WILL BE SHOW
            */
            mySMS.Sender = txtSender.Text.Trim();
            if (txtSender.Text != mySMS.Sender.ToString())
            {
                txtSender.Text = mySMS.Sender.ToString();
                MessageBox.Show("The sender you type is changed!", "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
                txtSender.SelectionStart = txtSender.Text.Length;
                txtSender.SelectionLength = 1;
                txtSender.Select();
                txtSender.Focus();
            }
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        private void txtSMSMsg_LostFocus(object sender, EventArgs e)
        {
            /*
             * 018@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *WHEN MESSAGE TEXT AREA LOST FOCUS, THE MESSAGE IS PASSED AT mySMS OBJECT CLASS USING THE mySMS.SMS_Message PROPERTY
             *IF THE mySMS OBJECT CLASS CHANGE THE MESSAGE SYNTAX A MESSAGE BOX WILL BE SHOW WITH THE EXCEPTION MESSAGE PASSED BY THE mySMS OBJECT CLASS
            */            
            try
            {
                mySMS.SMS_Message = txtSMSMsg.Text;
                LabelSMS.Text = "SMS Message " + mySMS.SMS_COUNT.ToString() + "   Chars " + mySMS.SMS_CHARS_COUNT.ToString() + "/" + mySMS.SMS_MAX_CAHRS.ToString(); ;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
                txtSMSMsg.Text = mySMS.SMS_Message;
                txtSMSMsg.SelectionStart = txtSMSMsg.Text.Length;
                txtSMSMsg.SelectionLength = 1;
                txtSMSMsg.Select();
                txtSMSMsg.Focus();
            }
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        private void txtSMSMsg_TextChanged(object sender, EventArgs e)
        {
            /*
             * 018b@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *WHEN MESSAGE TEXT AREA CHANGE, THE MESSAGE IS PASSED AT mySMS OBJECT CLASS USING THE mySMS.SMS_Message PROPERTY
             *IF THE mySMS OBJECT CLASS CHANGE THE MESSAGE SYNTAX A MESSAGE BOX WILL BE SHOW WITH THE EXCEPTION MESSAGE PASSED BY THE mySMS OBJECT CLASS
            */
            try
            {
                mySMS.SMS_Message = txtSMSMsg.Text;
                LabelSMS.Text = "SMS Message " + mySMS.SMS_COUNT.ToString() + "   Chars " + mySMS.SMS_CHARS_COUNT.ToString() + "/" + mySMS.SMS_MAX_CAHRS.ToString(); ;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
                txtSMSMsg.Text = mySMS.SMS_Message;
                txtSMSMsg.SelectionStart = txtSMSMsg.Text.Length;
                txtSMSMsg.SelectionLength = 1;
                txtSMSMsg.Select();
                txtSMSMsg.Focus();
            }
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        private void txtGateway_TextChanged(object sender, EventArgs e)
        {
            /*
             * 019@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *VERIFY AND PASS THE GATEWAY NUMBER TO THE mySMS.Gateway PROPERTY OF mySMS OBJECT CLASS
            */
            int gateX = 0;
            try
            {
                gateX = Convert.ToInt32(txtGateway.Text.ToString().Trim());
                if (gateX > 100)
                    gateX = 0;
                mySMS.Gateway = gateX;
                SetQuality();
            }
            catch
            {
                if (txtGateway.TextLength > 1)
                    txtGateway.Text = txtGateway.Text.Substring(txtGateway.TextLength - 1, 1);
                else
                    txtGateway.Text = "0";
            }
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        private void txtUser_TextChanged(object sender, EventArgs e)
        {
            /*
             * 020@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *PASS THE USER NAME TO THE mySMS.User PROPERTY OF mySMS OBJECT CLASS
             *EXCEPTIONS WILL BE SHOW AS A MESSAGE BOX
            */
            try
            {
                mySMS.User = txtUser.Text;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
                txtUser.Text = mySMS.User;
                txtUser.SelectionStart = txtUser.Text.Length;
                txtUser.SelectionLength = 1;
                txtUser.Select();
                txtUser.Focus();
            }
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        private void txtPassword_TextChanged(object sender, EventArgs e)
        {
            /*
             * 021@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *PASS THE PASSWORD TO THE mySMS.Password PROPERTY OF mySMS OBJECT CLASS
             *EXCEPTIONS WILL BE SHOW AS A MESSAGE BOX
            */
            try
            {
                mySMS.Password = txtPassword.Text;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
                txtPassword.Text = mySMS.Password;
                txtPassword.SelectionStart = txtPassword.Text.Length;
                txtPassword.SelectionLength = 1;
                txtPassword.Select();
                txtPassword.Focus();
            }
            //@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
        }
        private void btnSend_Click(object sender, EventArgs e)
        {
            /*
             * 022@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *TRY TO SEND SMS MESSAGES USING THE mySMS.Send() METHOD 
             *@@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
            */
            
            try
            {
                bool B;
                B = mySMS.Send();
                if (B)
                {
                    /*
                     * 023@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                     *IF SERVER RESPONSE IS True
                    */
                    MessageBox.Show("Message delivery succesfull", "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.None, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
                }
                else
                {
                    /*
                     * 024@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                     *IF SERVER RESPONSE IS False CHECK mySMS.ERR_CODE TO HAVE AN ERROR RESPONSE
                     *YOU CAN GET AN ERROR DESCRIPTION IN mySMS.ERR_DESCRIPTION 
                     * 
                     * 
                     * ERRORS in mySMS.ERR_CODE CAN BE:
                     * 0 = SENT ALL OK                   
                     * 1 = EMPTY MESSAGE                 
                     * 2 = GSM NUMBER ALREADY PRESENT    
                     * 3 = WRONG GSM FORMAT              
                     * 4 = CONNECTION ERROR              
                     * 5 = ONE OR MORE GSM NUMBERS FAILED
                     * 6 = NO GSM NUMBERS
                    */
                    if (mySMS.ERR_CODE == 5)
                    {
                        /*
                         * 025@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                         *IF mySMS.ERR_CODE VALUE IS 5 CHECK mySMS.get_Responses TO GET A SINGLE RESPONSE FOR EACH GSM NUMBER
                         **THE get_Responses IS AN Array THAT CONTAIN STRIGS WITH gsm NUMBERS AN RESPONSE*
                        */
                        string s = "";
                        for (int i = 0; i < mySMS.get_Responses.Count; i++)
                        {
                            if (mySMS.get_Responses[i].ToString().Contains("-Err"))
                            {
                                if (s != "")
                                    s += "\n";
                                s += mySMS.get_Responses[i];
                                /*
                                 * 026@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                                 *IN get_responses YOU CAN FIND GSM NUBER AND RESPONSES TYPE
                                 *KIND OF RESPONSES CAN BE:
                                 *
                                 *      +Ok     =MESSAGE OK                
                                 *      -Err 001=MESSAGE ERROR LOGIN FAILED      
                                 *      -Err 002=MESSAGE ERROR NO CREDIT       
                                 *      -Err 003=MESSAGE ERROR RINGTONE TOO LONG   
                                 *      -Err 004=MESSAGE ERROR GSM NUMBER        
                                 *      -Err 005=MESSAGE ERROR GSM NUMBER ABSENT      
                                 *      -Err 006=MESSAGE ERROR EMPTY MESSAGE  
                                 *      -Err 007=Message not enabled
                                 *      -Err 008=Server error while creating sms
                                 *      -Err 009=Client Time-out
                                 *      -Err 011=Missing user parameter
                                 *      -Err 012=Missing password parameter
                                 *      -Err 013=Missing destinations parameter
                                 *      -Err 090=Server busy, too many connections at this time
                                 *      -Err 099=UNKNOWN
                                */
                            }
                        }
                        /*
                         * 027@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                         *NEXT MESSAGE WILL SHOW ALL ERRORS AS IT PASSED FROM THE get_Responses ARRAY IN THE mySMS OBJECT THAT IS AN INSTANCE OF AgileTelecomSMS CLASS
                        */
                        MessageBox.Show(s, "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
                    }
                    else
                    {
                        /*
                         * 028@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                         *NEXT MESSAGE WILL SHOW THE ERROR DESCRIPTION IN mySMS.ERR_DESCRIPTION
                        */
                        MessageBox.Show(mySMS.ERR_DESCRIPTION, "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
                    }                   
                }              
            }
            catch (Exception ex)
            {
                /*
                 * 029@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
                 *NEXT MESSAGE WILL SHOW THE EXCEPTIONS ERROR MESSAGES 
                */
                MessageBox.Show(ex.Message, "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.DefaultDesktopOnly);
            }
            AgileTelecomSMS mySMS1 = new AgileTelecomSMS();
            mySMS1 = mySMS;
            mySMS = new AgileTelecomSMS();
            mySMS = mySMS1;
            //mySMS1.Dispose();
            /*
             * 030@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *THIS ENABLE THE TIMER THAT AUTOMATICALLY UPDATE YOUR CREDIT AFTER 10 SECOND 
            */
            timer1.Enabled = true;
        }
        private void txtNewGSM_KeyUp(object sender, KeyEventArgs e)
        {
            /*
             * 031@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *INTERCEPT A <ENTER> KEY AS AN ADD GSM TO A LIST
             *SEE 005@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
            */
            if (e.KeyCode == Keys.Enter)
            {
                //Control of international GSM syntax format 
                if (Regex.IsMatch(txtNewGSM.Text, "^\\+{1}\\d{10,15}$"))
                {
                    //Using add_GSM method to add a GSM number to DLL
                    mySMS.add_GSM(txtNewGSM.Text);
                    Populate_list();
                }
            }
        }
        private void btnUpdateCredit_Click(object sender, EventArgs e)
        {
            /*
             * 032@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *SEE HOW MUCH CREDIT IS IN YOUR ACCOUNT USING mySMS.get_Credit PROPERTY
             *THIS PROPERTY NEVER GIVE YOU AN ERROR RESPONSE BUT IF YOUR CREDIT STILL BE 0,00 MAYBE YOU HAVE TYPE A WRONG USER OR PASSWORD
            */
            if (txtUser.Text.Length > 3 & txtPassword.Text.Length > 3)
                lblCredit.Text = mySMS.get_Credit;
            else
                MessageBox.Show("Please type your User and Password.", "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1);
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            /*
             * 033@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *AUTOMATICALLY UPDATE CREDIT 10 SECONDS AFTER SENDING USING mySMS.get_Credit PROPERTY
            */
            timer1.Enabled = false;
            lblCredit.Text = mySMS.get_Credit;
        }
        private void chkTest_CheckedChanged(object sender, EventArgs e)
        {
            /*
             * 034@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *TEST THE SMS DELIVERY BY SETTING mySMS.Test PROPERTY VALUE = TRUE
            */
            if (chkTest.Checked)
            {
                btnSend.Text = "Send test";
                mySMS.Test = true;
            }
            else
            {
                btnSend.Text = "Send";
                mySMS.Test = false;
            }
        }

        private void PopulateSMSType()
        {
            /*
             * 035@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *THIS POPULATE THE SMS TYPE COMBOBOX IN THE FORM
             *SMS_Type IS AN OBJECT  THAT CONTAINS METHODS AND PROPERTY
            */

            int i;
            cboType.Items.Clear();
            for (i = 0; i < mySMS.SMS_Type.arrayList_Type.Count; i++)
            {
                cboType.Items.Add(mySMS.SMS_Type.arrayList_Type[i]);
            }
            i = cboType.FindString(mySMS.SMS_Type.Type);
            cboType.SelectedIndex = i;
        }
        private void cboType_SelectedIndexChanged(object sender, EventArgs e)
        {
            /*
             * 036@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *SELECT A DIFFERENT TYPE USING THE mySMS.SMS_Type.add_set_Type METHOD OF mySMS OBJECT CLASS
            */
            int i;
            try
            {
                mySMS.SMS_Type.add_set_Type(cboType.Text);
            }
            catch
            {
            }
            i = cboType.FindString(mySMS.SMS_Type.Type);
            cboType.SelectedIndex = i;
        }
        private void btnAddType_Click(object sender, EventArgs e)
        {
            /*
             * 037@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *IF NOT EXISTING, ADD AND SELECT A NEW TYPE USING THE mySMS.SMS_Type.add_set_Type METHOD OF mySMS OBJECT CLASS
            */
            if (MessageBox.Show("Sending particular file type extension need to be agreed by AgileTelecom servers.\nContact our technical staff for additional information.\nContinue to add new file extension type?", "AgileTelecomSMS DLL", MessageBoxButtons.YesNo) == DialogResult.No)
            {
                return;
            }
            int i;
            try
            {
                mySMS.SMS_Type.add_set_Type(cboType.Text);
                i = cboType.FindString(mySMS.SMS_Type.Type);
                if (i < 0)
                    cboType.Items.Add(cboType.Text);

                i = cboType.FindString(mySMS.SMS_Type.Type);
                cboType.SelectedIndex = i;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "AgileTelecomSMS DLL", MessageBoxButtons.OK, MessageBoxIcon.Warning, MessageBoxDefaultButton.Button1);
            }
            PopulateSMSType();
        }
        private void btnBrowse_Click(object sender, EventArgs e)
        {
            /*
             * 038@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *OPEN A TEXT FILE TO IMPORT A GSM TEXT LIST
             *THE TEXT FILE (*.TXT) MUST CONTAIN ONE GSM NUMBER FOR EACH ROWS TYPED IN INTERNATIONAL FORMAT Eg. +449999999999
            */
            OFD1.ShowDialog();
            string myS = OFD1.FileName.ToString();

            FileStream myFS;
            myFS = File.OpenRead(myS);
            byte[] b = new Byte[1024];
            UTF8Encoding temp = new UTF8Encoding(true);
            string SS = "";
            while (myFS.Read(b, 0, b.Length) > 0)
            {
                SS += temp.GetString(b);
            }
            myFS.Close();
            string[] stringSeparators = new string[] { "\n" };
            string[] TextList = SS.Split(stringSeparators, StringSplitOptions.RemoveEmptyEntries);
            /*
             * +039@@@@@@AgileTelecomSMS_DLL@@@@@@\@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *ADD EACH GSM NUMBER IN THE TEXT FILE TO mySMS CLASS OBJECT USING mySMS.add_GSM METHOD
            */
            for (int i = 0; i < TextList.Length; i++)
            {
                TextList[i] = TextList[i].Trim();
                TextList[i] = TextList[i].Replace("\0", "");
                if (Regex.IsMatch(TextList[i], "^\\+{1}\\d{10,15}$"))
                {
                    mySMS.add_GSM(TextList[i]);
                    Populate_list();
                }
            }
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            /*
             * +040@@@@@@AgileTelecomSMS_DLL@@@@@@\@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *SET THE chkHTTPS CHECKBOX ON THE FORM LIKE IS DLL Secure_Send OPTION (Usiing http or https)
            */
            chkHTTPS.Checked = mySMS.Secure_Send;
        }

        private void chkHTTPS_CheckedChanged(object sender, EventArgs e)
        {
            /*
             * +041@@@@@@AgileTelecomSMS_DLL@@@@@@\@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *SET THE DLL Secure_Send OPTION LIKE IS chkHTTPS CHECKBOX ON THE FORM (Usiing http or https)
            */
            mySMS.Secure_Send = chkHTTPS.Checked;
        }

        private void checkBoxHQ_CheckedChanged(object sender, EventArgs e)
        {
            /*
             * +042@@@@@@AgileTelecomSMS_DLL@@@@@@\@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *SET THE DLL QUALITY_HIGH OPTION LIKE IS checkBoxHQ CHECKBOX ON THE FORM 
             *AND FORCE THE GATEWAY IN THE txtGateway FORM FIELD (Gate = 0)
            */
            mySMS.QUALITY_HIGH = checkBoxHQ.Checked;
            txtGateway.Text = mySMS.Gateway.ToString();
        }

        private void checkBoxMQ_CheckedChanged(object sender, EventArgs e)
        {
            /*
             * +043@@@@@@AgileTelecomSMS_DLL@@@@@@\@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *SET THE DLL QUALITY_MEDIUM OPTION LIKE IS checkBoxMQ CHECKBOX ON THE FORM 
             *AND FORCE THE GATEWAY IN THE txtGateway FORM FIELD (Gate = 100)
            */
            mySMS.QUALITY_MEDIUM = checkBoxMQ.Checked;
            txtGateway.Text = mySMS.Gateway.ToString();
        }

        private void SetQuality()
        {
            /*
             * +044@@@@@@AgileTelecomSMS_DLL@@@@@@\@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *SET checkBoxHQ AND checkBoxMQ CHECKBOX ON THE FORM LIKE IS THE  
             * DLL QUALITY_HIGH AND QUALITY_MEDIUM OPTION
            */
            checkBoxHQ.Checked = mySMS.QUALITY_HIGH;
            checkBoxMQ.Checked = mySMS.QUALITY_MEDIUM;
        }

        private void textBoxDelivery_TextChenge(object sender, EventArgs e)
        {
            /*
             * 045@@@@@@AgileTelecomSMS_DLL@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
             *PASS DELIVERY CODE TO DLL TO ENABLE THE DELIVERY RESPONSE CALL TO YOUR SERVER 
             *(ASK TO AGILETELECOM TO ENABLE DELIVERY RESPONSE ON YOUR ACCOUNT)
            */
            mySMS.SMS_DELIVERY = textBoxDelivery.Text;   
        }        
    }
}